package com.pms.ocp.controller;


import com.pms.ocp.model.entity.OcpApiAudit;
import com.pms.ocp.model.entity.OcpApiModelRel;
import com.pms.ocp.model.entity.OcpApiSubs;
import com.pms.ocp.model.entity.OcpApiTenantRel;
import com.pms.ocp.model.vo.ResponseVO;
import com.pms.ocp.service.OcpApiAuditService;
import com.pms.ocp.service.OcpApiModelRelService;
import com.pms.ocp.service.OcpApiSubsService;
import com.pms.ocp.service.OcpApiTenantRelService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;


@Slf4j
@RequestMapping("/tenant")
@RestController
@Api(tags = "服务接口")
public class OcpDetailsController {

    @Autowired
    private OcpApiSubsService ocpApiSubsService;

    @Autowired
    private OcpApiAuditService ocpApiAuditService;

    @Autowired
    private OcpApiTenantRelService ocpApiTenantRelService;

    @Autowired
    private OcpApiModelRelService ocpApiModelRelService;


    @ApiOperation("服务订阅记录-查询")
    @PostMapping("/getocpapisublist")
    public ResponseVO getOcpApiSubsList(@RequestBody OcpApiSubs ocpApiSubs) {
        return ocpApiSubsService.getOcpApiSubsList(ocpApiSubs);
    }

    @ApiOperation("服务大事记-查询")
    @PostMapping("/getocpapiauditlist")
    public ResponseVO getOcpApiAuditList(@RequestBody OcpApiAudit ocpApiAudit) {
        return ocpApiAuditService.getOcpApiAuditList(ocpApiAudit);
    }

    @ApiOperation("服务大事记-查询详情")
    @PostMapping("/getocpapidetails")
    public ResponseVO getOcpApiDetails(@RequestBody OcpApiAudit ocpApiAudit){
        return ocpApiAuditService.sById(ocpApiAudit);
    }

    @ApiOperation("服务大事记-查询详情")
    @PostMapping("/getocpapi")
    public ResponseVO getOcpApi(@RequestBody OcpApiAudit ocpApiAudit){
        return ocpApiAuditService.OaaById(ocpApiAudit);
    }

    @ApiOperation("服务与应用拓扑图-查询")
    @PostMapping("/getoatrlist")
    public ResponseVO getOatrList(@RequestBody OcpApiTenantRel ocpApiTenantRel) {
        return ocpApiTenantRelService.getOatrList(ocpApiTenantRel);
    }

    @ApiOperation("服务与模型拓扑图-查询")
    @PostMapping("/getoamrlist")
    public ResponseVO getOamrList(@RequestBody OcpApiModelRel ocpApiModelRel) {
        return ocpApiModelRelService.getOamrList(ocpApiModelRel);
    }

    @ApiOperation("服务与模型拓扑图-关联查询详情")
    @PostMapping("/getoaabyid")
    public ResponseVO OaaById(@RequestBody OcpApiAudit ocpApiAudit) {
        return ocpApiAuditService.OaaById(ocpApiAudit);
    }

    @ApiOperation("服务大事记-导出")
    @RequestMapping("/export")
    public void exportExcel(@RequestBody(required = false) OcpApiAudit ocpApiAudit, HttpServletRequest request, HttpServletResponse response) {
        ocpApiAuditService.exportExcel(ocpApiAudit,request,response);
    }

}
